//+------------------------------------------------------------------+
//|                                     Close_All_Sells_At_Price.mq4 |
//|                                            Copyright  2008, WNW |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, WNW"
#property link          "1231988@gmail.com"


                                       
extern double CloseAllSellsPrice=1.500;     //The price at which you want to close all SELL trades.
                                          
extern int Slippage=5;
int i;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start()
{
Comment("CloseAllSells will close all trades at: ",DoubleToStr(CloseAllSellsPrice,4));

if (Ask >= CloseAllSellsPrice)
   {
    for(i=OrdersTotal()-1;i>=0;i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       int type   = OrderType();
               
        bool result = false;
    
    switch(type)
    {
      //Close opened long positions
//      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
//                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          break;

      //Close pending orders
//      case OP_BUYLIMIT  : result = OrderDelete( OrderTicket() );
//      case OP_BUYSTOP   : result = OrderDelete( OrderTicket() ); 
      case OP_SELLLIMIT : result = OrderDelete( OrderTicket() );
      case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
    }
    
    if(result == false)
    {
//      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(300);
    }  
  }

  return(0);
}
}

